<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset='utf-8' />
    <title>Mapbox-Visualisierung</title>
	<script src="distt/threebox.js" type="text/javascript"></script>
    <!--<script src="dist/threebox.js" type="text/javascript"></script> old version -->
    <meta name='viewport' content='initial-scale=1,maximum-scale=1,user-scalable=no' />
	<script src="https://code.jquery.com/jquery-3.4.1.js"></script>
    <!-- <script src='https://api.mapbox.com/mapbox-gl-js/v0.50.0/mapbox-gl.js'></script>
    <link href='https://api.mapbox.com/mapbox-gl-js/v0.50.0/mapbox-gl.css' rel='stylesheet' /> old version-->
	<script src='https://api.tiles.mapbox.com/mapbox-gl-js/v1.3.1/mapbox-gl.js'></script>
	<link href='https://api.tiles.mapbox.com/mapbox-gl-js/v1.3.1/mapbox-gl.css' rel='stylesheet' />
	
    <link rel="stylesheet" href="css/fontawesome/css/font-awesome.min.css"/>
    <link rel="stylesheet" href="css/main1.css"/>
	<!-- <link rel="stylesheet" href="css/battery.css" /> -->

    <style>
        body { margin:0; padding:0; }
        #map { position:absolute; top:0; bottom:0; width:100%; }
    </style>

</head>
<body>

<script src="utils/machineLearning/CarDetectionTrainingData.js"></script>
<script src="js\lib\NavBar.js"></script>
<script src="js\lib\DataModel.js"></script>
<script src="js\lib\Server.js"></script>
<script src="js\lib\WebService.js"></script>
<script src="js\lib\lib.js"></script>
<script src="js\lib\CarController.js"></script>

<script src="//cdn.rawgit.com/Mikhus/canvas-gauges/gh-pages/download/2.1.5/radial/gauge.min.js"></script>
<script src="js\GLTFLoader.js"></script>

<script src="js\MapboxEnvironment.js"></script>
<script src="js\Carbuild.js"></script>
<script src="js\InfoBox.js"></script>
<script src="js\config.js"></script>
<script src="js\CarObject.js"></script>
<!-- <script src="js/BatteryIcon.js"></script> -->

<div id="nav-menu" ></div>

<div id='map' class='map'></div>

<div id="myInfoBox" class="infoBox">
   <a href="javascript:void(0)" class="closebtn" onclick="infoBox.closeInfoBox()">&times;</a>
</div>

<div id="loader" class="disabled">
   <span>Loading...</span>
</div>

<div id="message" class="disabled"></div>

<canvas id="gauge" class = "mygauge"></canvas>

<!-- <div class="mainBattery">
								<div class='battery'>
									<div class='bottom'></div>
									<div class='middle'>
										<span class='glass'></span>
										<div class='fill'></div>
									</div>
									<div class='top-b'></div>
									<div class='top-a'></div>
								</div>
								<div class='reflection'>
									<div class='fade'></div>
									<div class='bottom'></div>
									<div class='middle'>
										<span class='glass'></span>
										<div class='fill'></div>
									</div>
									<div class='top-b'></div>
									<div class='top-a'></div>
								</div>
						
							</div>
							<span id='battery-value'></span> -->

<script>
  //set Mapbox Access-Token in Config.js
  if(!config) console.error("Access-Token not set!");
  mapboxgl.accessToken = config.accessToken;

  var CARS = {};
  var USER = {};
  var NUM_MAP_SECTOR = 1;

  var map;
  var mapbox = true;
  var mapCenter;
  var createdMap = false;

  var serverData = [];

  var infoBoxCreated = false;
  var clickedCarId = 1;
  var carNumber;
  var currentCarPosition;
  var currentCarId = 1;
  var carExists= false;

  //CAMERA
  var currentCameraId = 0;
  var zoomId = 0;
  var cameraAngle = [];

  let callback = null;
  var timeDelta = null;
  let simulationStarted = false;

  var carController = new CarController(mapbox);
  var setCars = new setCars();

  // ProgressBar
  let screenWidth = window.innerWidth;
  const progressWidth = screenWidth;
  var eveLis = true;
  var text = {
      frames: 0
  }
  var createdProgressbar = false;

  //init Navbar
  lib.initNav();

  /*
   //TODO - löschen
  function animate() {
      //TODO
      if (DataModel.simulationTimeDeltaMs > 0) {
          setTimeout(function() {requestAnimationFrame(animate);}, DataModel.simulationTimeDeltaMs);
      } else {
          requestAnimationFrame( animate );
      }
  }
  */

  function switchCar(carId) {
      currentCarId = carId;
  }
	
  function createEnvironment(){
	mapCenter = [serverData[1].posX, serverData[1].posY, 0];
	carNumber = serverData.length-1; 
	  
	//create 3D-map
	if(!createdMap){
		map = new MapboxEnvironment(mapCenter);
		createdMap = true;
		console.log("map created");
	}
     
      //create and move car with custom layers
      map.on('style.load', function() {
	  
         for(var x = 1;x <= carNumber;x++) {
              var mapid = "custom__layer" +x;
              map.addLayer({
                  "id": mapid,
                  "type": 'custom',
                  onAdd: function (map, gl) {				
                      onAdd(map, gl,x);					  
                  },
                  render: function (gl, matrix) {
                      threebox.update(true);

                  }
              });
          }
      });
	  

      //switch camera view - with c
      //zoom in and out - with z

      map.on('load', function() {
          map.getCanvas().focus();
          map.getCanvas().addEventListener('keydown', function(e) {
              e.preventDefault();

                  if(e.which === 67) {
                  console.log("c pushed" );
                  var top ={bearing: cameraAngle[currentCarId], pitch :0};
                  var back = {bearing: cameraAngle[currentCarId],pitch :60};
                  var front = {bearing: cameraAngle[currentCarId]-180,pitch :60};
                  var sideR = {bearing: cameraAngle[currentCarId]-90,pitch :60};
                  var sideL = {bearing: cameraAngle[currentCarId]+90,pitch :60};
                  var cameraArray= [top,back,front,sideR,sideL];

                  if(currentCameraId === 5 ){
                      currentCameraId=0
                  }
                  map.jumpTo(cameraArray[currentCameraId]);
                  currentCameraId++;


              } else if(e.which === 90) {
                  console.log("z pushed" );
                  var zoomlevel=[18,19,20,21,22];
                  if(zoomId === 5){
                      zoomId = 0;
                  }

                  map.jumpTo({zoom: zoomlevel[zoomId]});
                  zoomId++;
              }

          }, true);
      });

      //Raycasting - show info of clicked car
      map.on('click', function(e){

          // calculate objects intersecting the picking ray
          var intersects = threebox.queryRenderedFeatures(e.point)

          // if intersect exists show InfoBox 
          if (intersects[0]) {
              var nearestObject = intersects[0].object;
              for(var i = 1; i <= carNumber;i++){

                  if(CARS[i].model.id == nearestObject.parent.id){
                      clickedCarId = i;
                  }
              }
              infoBox.showInfoBox(clickedCarId);
          }
      });
  }


 
  DataModel.addHandler(DataModel.CARS_HANDLER_MAPBOX, function carsHandler(data, resolve, reject) {
      var flags = [];
      var uniqueData = [];
      var l = data.length;
      for( var i=0; i<l; i++) {
          if( flags[data[i].id]) continue;
          flags[data[i].id] = true;
          uniqueData.push(data[i]);
      }
      console.log(uniqueData);

      for(var i=1; i <= uniqueData.length; i++) {
          if(carExists){
			  //handle car data
              carController.handleData(uniqueData[i-1], i, resolve, mapbox);
              //updateBattery(uniqueData);
			  
          } else{
              //init Data and create Map and cars
			  if(i < uniqueData.length){
				serverData[i] = uniqueData[i-1];
			  }
			  else{
				serverData[i] = uniqueData[i-1];
				createEnvironment();
				console.log("map created");
				carExists = true;
			  }
			   
              window.setTimeout(resolve, 4000);
          }
      }
  },mapbox);


  function onAdd(map, mbxContext,i) {
	  //window.threebox = new Threebox(map, mbxContext);
      //threebox.setupDefaultLights();
	  
	  //create Threebox for 3D-Objects
	  window.threebox = new Threebox(map, mbxContext,{defaultLights: true});
	  
      var loader = new THREE.GLTFLoader();
      var carid = i;
      var carType = "porsche";

      var initCarPosition = [serverData[carid].posX, serverData[carid].posY, 0];
      var initCarRotation = [Math.PI/2, serverData[carid].steering, 0];

      CARS[carid] = setCars.build(carid,carType,initCarPosition,initCarRotation);

      //load car
      loader.load(CARS[carid].file, (function (object) {
          //scale and rotate car
          object.scene.scale.set(CARS[carid].modelScale,CARS[carid].modelScale,CARS[carid].modelScale);
          object.scene.rotation.set(CARS[carid].rotation[0],CARS[carid].rotation[1],CARS[carid].rotation[2]);

          CARS[carid].model = object.scene;

          //add car-objects to the positions
          threebox.addAtCoordinate(CARS[carid].model, CARS[carid].position,{preScale: 1});

          var anim = function anim() {
			carid = i;
              if(CARS[carid] != null && CARS.hasOwnProperty(carid)){

                  carController.correctCarAttitude(carid, mapbox);
				  threebox.moveToCoordinate(CARS[carid].model, CARS[carid].position );

                  if(infoBoxCreated && clickedCarId === carid){
                      infoBox.updateInfoBox(clickedCarId);
                  }

                  //create ProgressBar
				  if(createdProgressbar){
					text.frames = Server.nextFrameIdx;
					lib.updateProgressBar(eveLis);
					eveLis = false;
				  }
				 
                  cameraAngle[carid] = CARS[carid].targetStatus.steeringAtDestination;
                  currentCarPosition = [CARS[currentCarId].position[0],CARS[currentCarId].position[1]];

                  //CAMERA jump to current car position
                  map.jumpTo({center: currentCarPosition});
				  
				  
				  /*
                  var currentZoomLevel = map.getZoom();
                  if(currentZoomLevel > 21){
                      CARS[carid].model.scale.set(0.15,0.15,0.15);
                  }
                  else{
                      CARS[carid].model.scale.set(CARS[carid].modelScale,CARS[carid].modelScale,CARS[carid].modelScale);
                  }
				  */

                  if(callback != undefined){
                      carController.updateDestination(i, mapbox);
                      callback();
                      callback = undefined;
                  }

                  requestAnimationFrame(anim);
              }
			  
          };
          anim();

      }).bind(this));
  }

</script>
</body>
</html>
